// Con Clase Agosto 2023
// Ejemplo de generacin de cdigo QR de texto con clases
// Salvador Pozo
// Nota: si en la consola se usa el texto blanco sobre fondo negro
// el cdigo estar invertido y el cdigo no ser lejible.
// Se puede corregir esto de varios modos:
// - Intercambiar los espacios y los dots (aunque habra que aadir
//   dots extras alrededor del cdigo.
// - Modificar los colores asignados a las propiedades de la consola.
// - La ms sencilla, seleccionar el texto de la consola, que invierte
//   los colores.

#include <iostream>
#include "qrcodegen.hpp"

using namespace std;

using qrcodegen::QrCode;

int main() {
	int border = 2;
    char *dot="\333\333";
    char *esp="  ";

	const char *text = "https://conclase.net";
	const QrCode::Ecc errCorLvl = QrCode::Ecc::LOW;

	const QrCode qr = QrCode::encodeText(text, errCorLvl);

	for (int y = -border; y < qr.getSize() + border; y++) {
		for (int x = -border; x < qr.getSize() + border; x++) {
			std::cout << (qr.getModule(x, y) ? dot : esp);
		}
		std::cout << std::endl;
	}
	std::cout << std::endl;
    return 0;
}
